/*
 * configuration.h
 *
 *  Created on: 08.11.2018
  *  Updated 12.2021
 *      Author: georg
 */

#ifndef CONFIGURATION_H_
#define CONFIGURATION_H_
#include "lattice.h"
#include <cstring> // memcpy
template<class M,class L>
class SiteLinks{
public:
	typedef M TElement;
	typedef L TLattice;
	static const unsigned int numlinks=TLattice::numsitelinks;
	typedef TElement BaseSiteLink[numlinks];
private:
	BaseSiteLink links;
public:
	SiteLinks():links(){}
	TElement& operator[](const Index ind){
		return(links[ind]);
	}

	const TElement& operator[](const Index ind)const{
		return(links[ind]);
	}

};


template<class M, class L>
class Configuration{
public:
	typedef M TSiteElement;
	typedef L TLattice;
private:
	TSiteElement* array_;
	const TLattice& lattice_;
        void copyData(TSiteElement* ar1,TSiteElement* ar2){
            std::memcpy(ar2,ar1,lattice_.volume()*sizeof(TSiteElement));
        }
public:
       Configuration(const Configuration& conf): array_(nullptr),lattice_(conf.lattice()){
           array_=new TSiteElement[lattice_.volume()];
           copyData(conf.array_,array_);
       }
       
        const Configuration& operator=(const Configuration& conf){
           copyData(conf.array_,array_);
       }
       
       
           
	explicit Configuration(const TLattice& lattice): array_(nullptr),lattice_(lattice){
		array_=new TSiteElement[lattice_.volume()];
	}
	~Configuration(){
		delete[] array_;
	}
	 TSiteElement& operator[](const unsigned long ind){
		 return (array_[ind]);
	 }
	 const TSiteElement& operator[](const unsigned long ind)const{
		 return (array_[ind]);
	 }

	 const TLattice& lattice()const{
		 return (lattice_);
	 }

};



#endif /* CONFIGURATION_H_ */
