/*
 * parameterparser.h
 *
 *  Created on: 15.01.2019
 *      Author: georg
 */

#ifndef PARAMETERPARSER_H_
#define PARAMETERPARSER_H_

class ModelParameter {
public:
	double beta;
	ModelParameter() :
			beta(0.0){
	}
};

class UpdateParameter {
public:
	unsigned long numberofconfigs;
	unsigned long ntherm;
	UpdateParameter() :
			numberofconfigs(0), ntherm(0) {

	}
};

class CommandLineParser{
public:
	void printResults(GLattice::Coord& sizes,
			ModelParameter& param, UpdateParameter& updparam){
		std::cout<<"#Lattice size is (";
		for(Index i(0);i<DIM;i++){
		  std::cout<<" "<<sizes[i];
		}
		std::cout<<")"<<std::endl;
		std::cout << "# beta="<< param.beta << std::endl;
		std::cout << "#Thermalization:" << updparam.ntherm << " configs:"
				<< updparam.numberofconfigs << std::endl;
	}
   bool parseCommandLine(int argc, char** argv, GLattice::Coord& sizes,
		ModelParameter& param, UpdateParameter& updparam) {
	if (argc < 7 + 1) {
		std::cout
				<< "Usage ./program Size_x Size_y Size_z Size_t beta numberofconfigurations thermalization"
				<< std::endl;
		return (false);
	}
	Index argnum(1);
	for(Index i(0);i<DIM;i++){
	  sizes[i] = std::stoi(std::string(argv[argnum++]));
	}
	param.beta = std::stod(std::string(argv[argnum++]));
	updparam.numberofconfigs = std::stod(std::string(argv[argnum++]));
	updparam.ntherm = std::stod(std::string(argv[argnum++]));
	printResults(sizes,param,updparam);
	return (true);
}
};



#endif /* PARAMETERPARSER_H_ */
