/*
 * random.h
 *
 *  Created on: 07.11.2018
 *      Author: georg
 */

#ifndef RANDOMGENERATOR_H_
#define RANDOMGENERATOR_H_

#include <random>

/**
 * This class provides just a simple access to the
 * Mersenne twister random number generator provided
 * by the C++11 standard library.
 * Double numbers in range [0,1).
 * Default initialization: time(0) seed.
 * Alternative: seed as input.
 * Simple example:
 *  RandomNumberGenerator rand;
 *  double randomNumber=rand();
 *  double nextRandomNumber=rand();
 */

class RandomNumberGenerator{
private:
	std::mt19937 generator;
	std::uniform_real_distribution<double> dis;

public:
	RandomNumberGenerator():
	generator(time(0)),
	dis(0.0, 1.0)// This is the distribution [0,1).
{
}
	RandomNumberGenerator(unsigned int initialseed):
	generator(initialseed), dis(0.0, 1.0){
}
	double operator()(){
		return (dis(generator));
	}

};



#endif /* RANDOMGENERATOR_H_ */
